<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTakimUrun ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTakimUrun
 * @subpackage Arrays
 */
class ArrayOfTakimUrun extends AbstractStructArrayBase
{
    /**
     * The TakimUrun
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TakimUrun[]
     */
    public $TakimUrun;
    /**
     * Constructor method for ArrayOfTakimUrun
     * @uses ArrayOfTakimUrun::setTakimUrun()
     * @param \StructType\TakimUrun[] $takimUrun
     */
    public function __construct(array $takimUrun = array())
    {
        $this
            ->setTakimUrun($takimUrun);
    }
    /**
     * Get TakimUrun value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TakimUrun[]|null
     */
    public function getTakimUrun()
    {
        return isset($this->TakimUrun) ? $this->TakimUrun : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTakimUrun method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTakimUrun method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTakimUrunForArrayConstraintsFromSetTakimUrun(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTakimUrunTakimUrunItem) {
            // validation for constraint: itemType
            if (!$arrayOfTakimUrunTakimUrunItem instanceof \StructType\TakimUrun) {
                $invalidValues[] = is_object($arrayOfTakimUrunTakimUrunItem) ? get_class($arrayOfTakimUrunTakimUrunItem) : sprintf('%s(%s)', gettype($arrayOfTakimUrunTakimUrunItem), var_export($arrayOfTakimUrunTakimUrunItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TakimUrun property can only contain items of type \StructType\TakimUrun, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TakimUrun value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TakimUrun[] $takimUrun
     * @return \ArrayType\ArrayOfTakimUrun
     */
    public function setTakimUrun(array $takimUrun = array())
    {
        // validation for constraint: array
        if ('' !== ($takimUrunArrayErrorMessage = self::validateTakimUrunForArrayConstraintsFromSetTakimUrun($takimUrun))) {
            throw new \InvalidArgumentException($takimUrunArrayErrorMessage, __LINE__);
        }
        if (is_null($takimUrun) || (is_array($takimUrun) && empty($takimUrun))) {
            unset($this->TakimUrun);
        } else {
            $this->TakimUrun = $takimUrun;
        }
        return $this;
    }
    /**
     * Add item to TakimUrun value
     * @throws \InvalidArgumentException
     * @param \StructType\TakimUrun $item
     * @return \ArrayType\ArrayOfTakimUrun
     */
    public function addToTakimUrun(\StructType\TakimUrun $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TakimUrun) {
            throw new \InvalidArgumentException(sprintf('The TakimUrun property can only contain items of type \StructType\TakimUrun, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TakimUrun[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TakimUrun|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TakimUrun|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TakimUrun|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TakimUrun|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TakimUrun|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TakimUrun
     */
    public function getAttributeName()
    {
        return 'TakimUrun';
    }
}
