<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunKategori ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunKategori
 * @subpackage Arrays
 */
class ArrayOfUrunKategori extends AbstractStructArrayBase
{
    /**
     * The UrunKategori
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunKategori[]
     */
    public $UrunKategori;
    /**
     * Constructor method for ArrayOfUrunKategori
     * @uses ArrayOfUrunKategori::setUrunKategori()
     * @param \StructType\UrunKategori[] $urunKategori
     */
    public function __construct(array $urunKategori = array())
    {
        $this
            ->setUrunKategori($urunKategori);
    }
    /**
     * Get UrunKategori value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunKategori[]|null
     */
    public function getUrunKategori()
    {
        return isset($this->UrunKategori) ? $this->UrunKategori : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunKategori method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunKategori method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunKategoriForArrayConstraintsFromSetUrunKategori(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunKategoriUrunKategoriItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunKategoriUrunKategoriItem instanceof \StructType\UrunKategori) {
                $invalidValues[] = is_object($arrayOfUrunKategoriUrunKategoriItem) ? get_class($arrayOfUrunKategoriUrunKategoriItem) : sprintf('%s(%s)', gettype($arrayOfUrunKategoriUrunKategoriItem), var_export($arrayOfUrunKategoriUrunKategoriItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunKategori property can only contain items of type \StructType\UrunKategori, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunKategori value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunKategori[] $urunKategori
     * @return \ArrayType\ArrayOfUrunKategori
     */
    public function setUrunKategori(array $urunKategori = array())
    {
        // validation for constraint: array
        if ('' !== ($urunKategoriArrayErrorMessage = self::validateUrunKategoriForArrayConstraintsFromSetUrunKategori($urunKategori))) {
            throw new \InvalidArgumentException($urunKategoriArrayErrorMessage, __LINE__);
        }
        if (is_null($urunKategori) || (is_array($urunKategori) && empty($urunKategori))) {
            unset($this->UrunKategori);
        } else {
            $this->UrunKategori = $urunKategori;
        }
        return $this;
    }
    /**
     * Add item to UrunKategori value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunKategori $item
     * @return \ArrayType\ArrayOfUrunKategori
     */
    public function addToUrunKategori(\StructType\UrunKategori $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunKategori) {
            throw new \InvalidArgumentException(sprintf('The UrunKategori property can only contain items of type \StructType\UrunKategori, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunKategori[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunKategori|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunKategori|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunKategori|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunKategori|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunKategori|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunKategori
     */
    public function getAttributeName()
    {
        return 'UrunKategori';
    }
}
